<?php

try {

    include_once "./auth.php";
	$bd = new PDO($dsn,$user,$pass,array(PDO::MYSQL_ATTR_INIT_COMMAND => "SET NAMES utf8"));
    $domain_name = "http://5ce.me:80/";
    $type_output = "";

    //get username, password, type, output, category
    $username = parseCleanValue($_GET["username"]);
    $password = parseCleanValue($_GET["password"]);
    $device_key = parseCleanValue($_GET["type"]);
    $outputKey = parseCleanValue($_GET["output"]);
    $category = isset($_GET['category']) ? parseCleanValue($_GET["category"]) : 1;


    /** Categorias
     * "1" => canais
     * "2" => filmes
     * "4" => radio
     * "5" => series
    */

    //verificar login
    $query = 'SELECT `id`, `username`, `enabled`, `exp_date`, `password` FROM `users` WHERE `username` = '. "'" .$username. "'" .' AND `password` = '. "'" .$password. "'" .' LIMIT 1';
    $stmt = $bd->prepare($query);
    $stmt->execute();
    if($stmt->rowCount() > 0){
        $consulta = $stmt->fetch(PDO::FETCH_ASSOC);

        ini_set('memory_limit', -1);
        if ($output = GenerateList($bd,$consulta,$consulta['id'],$device_key,$outputKey,true,$category)) {
            echo $output;
            die;
        }
    }

    //CheckFlood();
    http_response_code(404);
    exit();


} catch (Exception $e) {
    echo $e->getMessage();
}

function GenerateList($bd, $userinfo, $user_id, $device_key, $output_key = 'ts', $force_download = false, $category = 1){

    global $domain_name;
    global $type_output;

    if (empty($device_key)) {
        return false;
    }
    //verificar se a lista está ativa e/ou expirada antes de ir atras das info
    if (empty($userinfo)) {
        return false;
    }
    if (!empty($userinfo['exp_date']) && time() >= $userinfo['exp_date']) {
        return false;
    }

    if ($output_key == 'mpegts') {
        $output_key = 'ts';
    }
    if ($output_key == 'hls') {
        $output_key = 'm3u8';
    }

    $user_info = getUserInfo($bd,$user_id);

    $query = 'SELECT t1.*,t2.*
    FROM `devices` t1
    LEFT JOIN `access_output` t2 ON t2.access_output_id = t1.default_output
    WHERE t1.device_key = '."'".$device_key."'".' LIMIT 1';
    $stmt = $bd->prepare($query);
    $stmt->execute();
    if($stmt->rowCount() > 0){
        $device_info = $stmt->fetch(PDO::FETCH_ASSOC);
        $data = '';

        $arrConteudo = array();

        //verificar qual o tipo de m3u8 devo gerar
        if($category == "1"){
            //"1" => canais
            $query = "SELECT a.id, a.type, b.category_name, a.stream_display_name, a.stream_source, a.stream_icon FROM streams as a inner join stream_categories as b on a.category_id = b.id and a.type = 1";
            $stmt = $bd->prepare($query);
            $stmt->execute();
            $consulta = $stmt->fetchAll(PDO::FETCH_ASSOC | PDO::FETCH_GROUP);
            foreach($user_info['channel_ids'] as $idChannel){
                if (isset($consulta[$idChannel])) {
                    array_push($arrConteudo,$consulta[$idChannel][0]);
                    $newid = sizeof($arrConteudo)-1;
                    $arrConteudo[$newid]['id'] = $idChannel;
                }
            }
            //verifico se existe algum retorno, se não existir eu retorno false
            if(sizeof($arrConteudo) == 0){
                return false;
            }

        } elseif ($category == "2"){
            //"2" => filmes
            $type_output = "movie";
            $query = "SELECT a.id, a.type, b.category_name, a.stream_display_name, a.stream_source, a.movie_propeties, a.target_container FROM streams as a inner join stream_categories as b on a.category_id = b.id and a.type = 2";
            $stmt = $bd->prepare($query);
            $stmt->execute();
            $consulta = $stmt->fetchAll(PDO::FETCH_ASSOC | PDO::FETCH_GROUP);
            foreach($user_info['channel_ids'] as $idChannel){
                if (isset($consulta[$idChannel])) {
                    array_push($arrConteudo,$consulta[$idChannel][0]);
                    $newid = sizeof($arrConteudo)-1;
                    $arrConteudo[$newid]['id'] = $idChannel;
                    $arrConteudo[$newid]['target_container'] = json_decode($arrConteudo[$newid]['target_container'], true);
                    $arrConteudo[$newid]['movie_propeties'] = json_decode($arrConteudo[$newid]['movie_propeties'], true);
                }
            }
            //verifico se existe algum retorno, se não existir eu retorno false
            if(sizeof($arrConteudo) == 0){
                return false;
            }

        } elseif ($category == "4"){
            //"4" => radio
            $type_output = "";
            $query = "SELECT id, type, stream_display_name, stream_source, stream_icon FROM streams where type = 4";
            $stmt = $bd->prepare($query);
            $stmt->execute();
            $consulta = $stmt->fetchAll(PDO::FETCH_ASSOC | PDO::FETCH_GROUP);
            foreach($user_info['channel_ids'] as $idChannel){
                if (isset($consulta[$idChannel])) {
                    array_push($arrConteudo,$consulta[$idChannel][0]);
                    $newid = sizeof($arrConteudo)-1;
                    $arrConteudo[$newid]['id'] = $idChannel;
                    $arrConteudo[$newid]['category_name'] = "Radios";
                }
            }
            //verifico se existe algum retorno, se não existir eu retorno false
            if(sizeof($arrConteudo) == 0){
                return false;
            }

        } elseif ($category == "5"){
            //"5" => series
            $type_output = "series";
            $query = "SELECT a.id, a.title, a.category_id, b.category_name, a.cover  FROM series as a inner join stream_categories as b on a.category_id = b.id";
            $stmt = $bd->prepare($query);
            $stmt->execute();
            $consulta = $stmt->fetchAll(PDO::FETCH_ASSOC | PDO::FETCH_GROUP);
            foreach($user_info['series_ids'] as $idSerie){
                if (isset($consulta[$idSerie])) {
                    $query = "SELECT a.series_id, a.stream_id, b.stream_display_name, b.target_container, b.movie_propeties FROM series_episodes as a inner join streams as b on a.stream_id = b.id and a.series_id = ".$idSerie;
                    $stmt = $bd->prepare($query);
                    $stmt->execute();
                    $episodios = $stmt->fetchAll(PDO::FETCH_ASSOC);
                    foreach($episodios as $ep){
                        array_push($arrConteudo,array(
                            "id" => $ep['stream_id'], //episodio id
                            "category_name" => $consulta[$idSerie][0]['category_name'],
                            "stream_icon" => $consulta[$idSerie][0]['cover'],
                            "stream_display_name" => $consulta[$idSerie][0]['title']." ".$ep['stream_display_name'],
                            "target_container" =>  json_decode($ep['target_container'], true), 
                            "movie_propeties" => json_decode($ep['movie_propeties'], true)
                        ));
                    }
                }
            }
            //verifico se existe algum retorno, se não existir eu retorno false
            if(sizeof($arrConteudo) == 0){
                return false;
            }

        } else {
            //categoria invalida
            return false;
        }

        if (!empty($device_info['device_header'])) {
            $data = str_replace(array('{BOUQUET_NAME}', '{USERNAME}', '{PASSWORD}', '{SERVER_URL}', '{OUTPUT_KEY}'), array('bouquet_name', $user_info['username'], $user_info['password'], $domain_name, $output_key), $device_info['device_header']) . '
';
        }
        if (!empty($device_info['device_conf'])) {
            if (preg_match('/\\{URL\\#(.*?)\\}/', $device_info['device_conf'], $matchs)) {
                $rMatchs = str_split($matchs[1]);
                $url_pattern = $matchs[0];
            } else {
                $rMatchs = array();
                $url_pattern = '{URL}';
            }
            foreach($arrConteudo as $row){

                $url = $domain_name . ($type_output != "" ? "{$type_output}/" : "" ) ."{$user_info['username']}/{$user_info['password']}/{$row['id']}" . ($type_output != "" ? ".{$row['target_container'][0]}" : "" );
                $icon = !empty($row['movie_propeties']['movie_image']) ? $row['movie_propeties']['movie_image'] : $row['stream_icon'];
                $data .= str_replace(array($url_pattern, '{CHANNEL_NAME}', '{CHANNEL_ID}', '{CATEGORY}', '{CHANNEL_ICON}'), array(str_replace($rMatchs, array_map('urlencode', $rMatchs), $url), $row['stream_display_name'], $row['id'], $row['category_name'], $icon), $device_info['device_conf']) . '
';
            }
            $data .= $device_info['device_footer'];
            $data = trim($data);
        }

        if ($force_download === true) {
            header('Content-Description: File Transfer');
            header('Content-Type: application/octet-stream');
            header('Expires: 0');
            header('cache-Control: must-revalidate');
            header('Pragma: public');
            header('Content-Disposition: attachment; filename="' . str_replace('{USERNAME}', $user_info['username'], $device_info['device_filename']) . '"');
            header('Content-Length: ' . strlen($data));
            echo $data;
            die;
        }
        return $data;
        

    }

    return false;

    


};

function parseCleanValue($val){
    if ($val == '') {
        return '';
    }
    $val = str_replace('&#032;', ' ', stripslashes($val));
    $val = str_replace(array('', '', ''), '', $val);
    $val = str_replace('<!--', '&#60;&#33;--', $val);
    $val = str_replace('-->', '--&#62;', $val);
    $val = str_ireplace('<script', '&#60;script', $val);
    $val = preg_replace('/&amp;#([0-9]+);/s', '&#\\1;', $val);
    $val = preg_replace('/&#(\\d+?)([^\\d;])/i', '&#\\1;\\2', $val);
    return trim($val);
};

function getUserInfo($bd,$user_id){
    $query = "SELECT * FROM `users` WHERE `id` = '".$user_id."'";
    $stmt = $bd->prepare($query);
    $stmt->execute();
    if($stmt->rowCount() > 0){
        $user_info = $stmt->fetch(PDO::FETCH_ASSOC);
        $user_info['bouquet'] = json_decode($user_info['bouquet'], true);
        $arrSeries = $arrStreams = array();
        $bqt = getBouquets($bd);
        foreach ($user_info['bouquet'] as $id) {
            if (isset($bqt[$id]['streams'])) {
                $arrStreams = array_merge($arrStreams, $bqt[$id]['streams']);
            }
            if (isset($bqt[$id]['series'])) {
                $arrSeries = array_merge($arrSeries, $bqt[$id]['series']);
            }
        }
        $user_info['channel_ids'] = array_unique($arrStreams);
        $user_info['series_ids'] = array_unique($arrSeries);

        return $user_info;
    }

    return false;
}

function getBouquets($bd){
    $output = array();
    $stmt = $bd->prepare('SELECT `id`,`bouquet_channels`,`bouquet_series` FROM `bouquets`');
    $stmt->execute();
    $consulta = $stmt->fetchAll();
    foreach($consulta as $value){
        $output[$value['id']]['streams'] = json_decode($value['bouquet_channels'], true);
        $output[$value['id']]['series'] = json_decode($value['bouquet_series'], true);
    }
    return $output;
}
